import pytest

from functions import add, factorial


# def(x, y) ==> x+y

def test_add():
    assert add(3, -2) == 1
    assert add(1 / 3, 1 / 2) == 0.8333333333333333
    assert add("doc", "strings") == 'docstrings'


def test_add2():
    # Test if the result of adding two strings is a string
    assert isinstance(add("doc", "strings"), str)

    # Test if the result of adding two integers is an integer
    assert isinstance(add(3, -2), int)

    # Test if the result of adding two floats is a float
    assert isinstance(add(1.5, 2.3), float)

    # Test if the result of adding an integer and a float is a float
    assert isinstance(add(1.5, 0.5), float)


def test_factorial_for_small_values():
    results = [factorial(n) for n in range(6)]
    expected = [1, 1, 2, 6, 24, 120]
    assert results == expected


def test_factorial_for_large_value():
    result = factorial(30)
    expected = 265252859812191058636308480000000
    assert result == expected


def test_factorial_for_negative_value():
    with pytest.raises(ValueError, match="n must be >= 0"):
        factorial(-1)


def test_factorial_for_non_exact_floats():
    with pytest.raises(ValueError, match="n must be exact integer"):
        factorial(30.1)


def test_factorial_for_exact_float():
    result = factorial(30.0)
    expected = 265252859812191058636308480000000
    assert result == expected


def test_factorial_for_large_floats():
    with pytest.raises(OverflowError, match="n too large"):
        factorial(1e100)
